// script for filtering posts on TDF planet by author
const sidebar = document.getElementsByClassName('sidebar')[0];
const authors = sidebar.getElementsByTagName('li');
// the cookie value is a comma-separated string of the author class names
var hidden = getCookie("hidden") ? getCookie("hidden").split(",") : new Array();
function setDisplay(nodes, value) {
    for (let node of nodes) {
        node.style.display = value;
    }
}
function getCookie(name) {
  let cookie = {};
  document.cookie.split(';').forEach(function(el) {
    let [k,v] = el.split('=');
    cookie[k.trim()] = v;
  })
  return cookie[name];
}
// hide posts by disabled folks
if (hidden.length > 0) for (i in hidden) {
    let divclasses = "channelgroup " + hidden[i];
    let posts = document.getElementsByClassName(divclasses);
    setDisplay(posts, 'none');
}
// create checkboxes upon page load
for (let author of authors) {
    let checkbox = document.createElement("input");
    checkbox.setAttribute('type', 'checkbox');
    if (!hidden.includes(author)) {
        checkbox.setAttribute('checked', '');
    }
    author.insertBefore(checkbox, author.firstChild);
}
function hideshow(checkbox) {
    let listitem = checkbox.parentNode;
    let listclass = listitem.className;
    let divclasses = "channelgroup " + listitem.className;
    let posts = document.getElementsByClassName(divclasses);
    let i = hidden.indexOf(listclass);
    if (checkbox.checked) {
        // if checkbox was checked, remove class name from array
        if (hidden[i]) hidden.splice(i, 1);
        setDisplay(posts, '');
    } else {
        // if checkbox was unchecked, add class name to the end of array
        if (!hidden[i]) hidden[hidden.length] = listclass;
        setDisplay(posts, 'none');
    }
    document.cookie = 'hidden=' + hidden.join(",") + ';max-age=31536000';    
}
function setEvent() {
    let checkboxes = sidebar.getElementsByTagName('input');
    for (let checkbox of checkboxes) {
        if (checkbox.type == 'checkbox') {
            checkbox.onclick = function(event) {
                hideshow(event.target)
            }
        }        
    }
}
window.onload = setEvent;
